//
// Created by philipp on 15.01.18.
//

#include "../include/NetworkingLib/Stream.h"

namespace networking
{
namespace stream
{
namespace internal
{

std::uint32_t numDataBytesFromBuffer(boost::asio::streambuf & streambuf)
{
    auto numDataBytesStr = utils::stringFromStreambuf(streambuf, 4);
    return utils::fromBigEndian<4, std::uint32_t>((const std::uint8_t *) numDataBytesStr.c_str());
}

std::size_t getNumRemainingBytes(std::size_t numBytesTransferred, std::uint32_t numDataBytes)
{
    using networking::internal::Frame;
    std::size_t numRemainingBytes = 0;
    if (numDataBytes > numBytesTransferred - Frame::HEADER_SIZE)
        numRemainingBytes = numDataBytes - numBytesTransferred - Frame::HEADER_SIZE;
    return numRemainingBytes;
}

}
}
}